<template>
  <div class="modal" :class="{ 'd-block': open }" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title text-black-50">{{ title }}</h5>
          <button
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
            @click="closeForm"
          >
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <ul class="list-group">
            <li v-if="isSectionOpen.primary" class="list-group-item">
              <slot name="primary">Primary Actions</slot>
            </li>
            <li v-if="isSectionOpen.navigation" class="list-group-item">
              <slot name="navigation">Naviagtion Actions</slot>
            </li>
            <li v-if="isSectionOpen.secondary" class="list-group-item">
              <slot name="secondary">Secondary Actions</slot>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <teleport to="body">
      <overlay :open="open" />
    </teleport>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType } from "vue";
import Overlay from "../components/Overlay.vue";

type sectionOptions = "primary" | "secondary" | "naviagtion";

export default defineComponent({
  components: { Overlay },
  props: {
    title: {
      type: String,
    },
    open: {
      type: Boolean,
    },
    sections: {
      type: Array as PropType<sectionOptions[]>,
      required: true,
    },
  },
  computed: {
    isSectionOpen() {
      const sections: { [keys in sectionOptions]: boolean } = {
        primary: false,
        secondary: false,
        naviagtion: false,
      };
      this.sections.forEach((section) => {
        sections[section] = true;
      });
      return sections;
    },
  },
  methods: {
    closeForm() {
      this.$emit("close");
    },
  },
});
</script>

<style scoped>
.modal-body {
  padding: 0;
}
.list-group-item {
  padding: 1rem;
  display: grid;
  grid-template-columns: repeat(1, minmax(0, 1fr));
  gap: 0.625rem;
}
.list-group-item {
  border-top: 0;
}
</style>
